﻿using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class Task
	{
		public readonly SingleTask task;
		public readonly List<SingleTask> lemmaTasks;
		public readonly List<TaskLemma> lemmata;

		public Task(SingleTask task, List<SingleTask> lemmaTasks, List<TaskLemma> lemmata)
        {
			this.task = task;
			this.lemmaTasks = lemmaTasks;
			this.lemmata = lemmata;
		}

        public string ToString(bool showConfig)
        {
			string res = "Aufgabenstellung:\r\n";
			res += task.ToString(showConfig);
			if (lemmaTasks.Count > 0) res += "Proof Lemmata:\r\n";
			foreach (SingleTask lemma in lemmaTasks)
				res += lemma.ToString(showConfig);
				if (lemmata.Count > 0) res += "Lemmata:\r\n";
				foreach (TaskLemma lemma in lemmata)
					res += lemma.ToString();
			return res;
        }
    }
}
