﻿using Eingabeverwaltung.Parser.ADT_Parser;
using Eingabeverwaltung.Metamodell;
using Antlr4.Runtime.Tree;
using Antlr4.Runtime;

namespace Eingabeverwaltung.Parser
{
	public static class ADT_Antlr
	{
		public static ADT parse(string ADT_input)
        {
            // Building Architecture for Syntax analysis
            ICharStream chars = new AntlrInputStream(ADT_input);
			ITokenSource lexer = new ADTLexer(chars);
			ITokenStream tokens = new CommonTokenStream(lexer);
			ADTParser parser = new ADTParser(tokens);

            // Properties for Syntax analysis
            parser.BuildParseTree = true;
            parser.RemoveErrorListeners();
            ErrorListener errorListener = new ErrorListener();
            parser.AddErrorListener(errorListener);

            // Syntax analysis
            ADTParser.AdtContext tree = parser.adt();
            if (parser.NumberOfSyntaxErrors > 0) errorListener.throwErrors();

            // Semantic analysis
            Container container = new Container();
            Listener_Helper LH = new Listener_Helper();
            IADTListener adt_Listener = new ADT_Listener(container,LH);
			ParseTreeWalker.Default.Walk(adt_Listener, tree);
            LH.close();

            return container.ADT;
        }
	}
}
