﻿using Eingabeverwaltung.Parser.Proof_Parser;
using Eingabeverwaltung.Metamodell;
using Antlr4.Runtime.Tree;
using Antlr4.Runtime;

namespace Eingabeverwaltung.Parser
{
	public static class Proof_Antlr
	{
		/// <summary>
		/// Requires a Container with filled ADT and Task
		/// </summary>
		/// <param name="Task_input"></param>
		/// <param name="container"></param>
		/// <returns></returns>
		public static void parse(string Proof_input, Container container)
		{
			// Building Architecture for Syntax analysis
			ICharStream chars = new AntlrInputStream(Proof_input);
			ITokenSource lexer = new ProofLexer(chars);
			ITokenStream tokens = new CommonTokenStream(lexer);
			ProofParser parser = new ProofParser(tokens);

			// Properties for Syntax analysis
			parser.BuildParseTree = true;
			parser.RemoveErrorListeners();
			ErrorListener errorListener = new ErrorListener();
			parser.AddErrorListener(errorListener);

			// Syntax analysis
			ProofParser.ProofContext tree = parser.proof();
			if (parser.NumberOfSyntaxErrors > 0) errorListener.throwErrors();

			// Semantic analysis
            Listener_Helper LH = new Listener_Helper(container.ADT.sorts, container.ADT.operations, container.ADT.axioms);
            // create Proof without TransformationSteps
            IProofListener PL = new Proof_Listener(container,LH);
			ParseTreeWalker.Default.Walk(PL, tree);
            // walk again and create all TransformationSteps: Now cycles are no Problem anymore.
            IProofListener TL = new TransformationStep_Listener(container,LH);
			ParseTreeWalker.Default.Walk(TL, tree);
            LH.close();
		}
	}
}
